#lang racket
(define list1 '(1 2 3 4))
(define list2 '(x y z w))

(define myLength1
    (lambda (x)
      (if (empty? x)
          0
          (+ 1 (myLength1 (cdr x))))))

(define myLength2 
    (lambda (xs)
      (cond ((empty? xs) 0)
            (else (+ 1 (myLength2 (cdr xs)))))))

;(define add2 (lambda (x y) (+ x y)))

(define add2List 
   (lambda (xs ys)
     (cond [(or (empty? xs) (empty? ys)) 0]
           [else (+ (car xs) (car ys) (add2List (cdr xs) (cdr ys)))])))

; (dot '(1 2 3) '(3 4 5)) ==> 1*3 + 2*4 + 3*5 ==> 1*3 + (dot '(2 3) '(4 5))
(define dot 
   (lambda (xs ys)
     (cond [(or (empty? xs) (empty? ys)) 0]
           [else (+ (* (car xs) (car ys)) (dot (cdr xs) (cdr ys)))])))

;(myLength1 '(1 2 3))
;(myLength2 '(1 2 3))
;(add2 3 4)
;(add2List '(1 2) '(1 2 3))
;(add2List '(1 2 3 4) '(1 2))
;(dot '(1 2 3) '(4 5 6))
;(dot '(1 1 1) '(3 4 5 6 7 8))
;(dot '() '(1 1 1))
;(dot '(1 1 1 1) '())
;(dot '() '())
;(dot '(1) '(3))


; two higher order functions, map & reduce

; (map f '(1 2 3)) ==> ((f 1) (f 2) (f 3))  ==> (f 1) cons (map f '(2 3))
(define myMap
  (lambda (f xs)
    (cond [(empty? xs) '()]
          [else (cons (f (car xs)) (myMap f (cdr xs)))])))

(myMap (lambda (x) (* x x)) '(2 3 4 5))


;(reduce op init '(x y z w)) ==> (op z (op y (op z (op w init))))
;                                    x  + (y  + (z  + (w + init)))

(define myReduce
  (lambda (op init xs)
    (cond [(empty? xs) init]
          [else (op (car xs) (myReduce op init (cdr xs)))])))

(myReduce + 0 '(1 2 3 4)) ; sum of the list
(myReduce * 1 '(2 3 4 5)) ; product of the list
; Here is a baby example of "map reduce"
(myReduce + 0 (myMap (lambda (x) (* x x)) '(2 3 4 5))) ; 2^2 + 3^2 + 4^2 + 5^2

; reduce is also called fold right (and there is another fold, fold left)


; nested lambda expressions (nested functions)
(define makeAdder
  (lambda (x)
    (lambda (y) (+ x y)))) ; this lambda is nested in the previous lambda

(define add2 (makeAdder 2))
(define add3 (makeAdder 3))
(add2 4)
(add2 1)
(add3 4)
(add3 1)
add2